/*	Part of the VGA low-level mass register setting stuff derived from code by
	\Firebug\
*/

#include <unistd.h>
#include <sys/types.h>
#include <signal.h>
#include <sys/ioctl.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include <strings.h>
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <assert.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <linux/joystick.h>

#include "vgavblank.h"
#include "../../driver.h"
#include "../../general.h"

#include <vga.h>
#include <vgakeyboard.h>
#include "io.h"

int vmode=1;
static int conlock=0;
static unsigned char *ScreenLoc;
static int didup=0;
static int winit=0;
int InitSound(void);
void TrashSound(void);

int vretrace=1;

void UpdateDriver(void)
{
 KeyboardUpdate();
}

static void clonehandler3(void)
{
didup=keyboard_update();
}

static int TimerSignal(int freq, void (*Handler)(int))
{
 struct itimerval T;
 T.it_interval.tv_sec=T.it_value.tv_sec=0;
 T.it_interval.tv_usec=
 T.it_value.tv_usec=(1000000/freq)-5000;
 setitimer(ITIMER_REAL,&T,NULL);
 signal(SIGALRM,Handler);
 return(1);
}

static void DoClone(void)
{
 TimerSignal(1,(void *)clonehandler3);
}



typedef struct {
  unsigned short p;
  unsigned char i;
  unsigned char v;
} vgareg;

vgareg v256x240[] =
{
        { 0x3c2, 0x0, 0xe3},
        { 0x3d4, 0x0, 0x4f},
        { 0x3d4, 0x1, 0x3f},
        { 0x3d4, 0x2, 0x40},
        { 0x3d4, 0x3, 0x92},
        { 0x3d4, 0x4, 0x44},
        { 0x3d4, 0x5, 0x10},
        { 0x3d4, 0x6, 0x0a},
        { 0x3d4, 0x7, 0x3e},
        { 0x3d4, 0x8, 0x00},
        { 0x3d4, 0x9, 0x41},
        { 0x3d4, 0xa, 0x00},
        { 0x3d4, 0xb, 0x00},
        { 0x3d4, 0xc, 0x00},
        { 0x3d4, 0xd, 0x00},
        { 0x3d4, 0xe, 0x00},
        { 0x3d4, 0xf, 0x00},
        { 0x3d4, 0x10, 0xea},
        { 0x3d4, 0x11, 0xac},
        { 0x3d4, 0x12, 0xdf},
        { 0x3d4, 0x13, 0x20},
        { 0x3d4, 0x14, 0x40},
        { 0x3d4, 0x15, 0xe7},
        { 0x3d4, 0x16, 0x06},
        { 0x3d4, 0x17, 0xa3},
	{ 0x3c4, 0x1, 0x1},
	{ 0x3c4, 0x4, 0xe},
	{ 0x3ce, 0x5, 0x40},
	{ 0x3ce, 0x6, 0x5},
	{ 0x3c0, 0x10, 0x41},
	{ 0x3c0, 0x13, 0x0}
};

vgareg v256x224S[] =
{
	{ 0x3c2, 0x0, 0xe3},
	{ 0x3d4, 0x0, 0x5f},
	{ 0x3d4, 0x1, 0x3f},
	{ 0x3d4, 0x2, 0x40},
	{ 0x3d4, 0x3, 0x82},
	{ 0x3d4, 0x4, 0x4e},
	{ 0x3d4, 0x5, 0x96},
	{ 0x3d4, 0x6, 0x5},
	{ 0x3d4, 0x7, 0x1},
	{ 0x3d4, 0x8, 0x0},
	{ 0x3d4, 0x9, 0x40},
	{ 0x3d4, 0x10, 0xea},
	{ 0x3d4, 0x11, 0xac},
	{ 0x3d4, 0x12, 0xdf},
	{ 0x3d4, 0x13, 0x20},
	{ 0x3d4, 0x14, 0x40},
	{ 0x3d4, 0x15, 0xe7},
	{ 0x3d4, 0x16, 0x6},
	{ 0x3d4, 0x17, 0xe3},
	{ 0x3c4, 0x1, 0x1},
	{ 0x3c4, 0x4, 0xe},
	{ 0x3ce, 0x5, 0x40},
	{ 0x3ce, 0x6, 0x5},
	{ 0x3c0, 0x10, 0x41},
	{ 0x3c0, 0x13, 0x0}
};

vgareg v256x256[] =
{
	{ 0x3c2, 0x0, 0xe3},
	{ 0x3d4, 0x0, 0x5f},
	{ 0x3d4, 0x1, 0x3f},
	{ 0x3d4, 0x2, 0x40},
	{ 0x3d4, 0x3, 0x82},
	{ 0x3d4, 0x4, 0x4a},
	{ 0x3d4, 0x5, 0x9a},
	{ 0x3d4, 0x6, 0x23},
	{ 0x3d4, 0x7, 0xb2},
	{ 0x3d4, 0x8, 0x0},
        { 0x3d4, 0x9, 0x61},
	{ 0x3d4, 0x10, 0xa},
	{ 0x3d4, 0x11, 0xac},
	{ 0x3d4, 0x12, 0xff},
        { 0x3d4, 0x13, 0x20},
        { 0x3d4, 0x14, 0x40},
	{ 0x3d4, 0x15, 0x7},
	{ 0x3d4, 0x16, 0x1a},
	{ 0x3d4, 0x17, 0xa3},
	{ 0x3c4, 0x1, 0x1},
	{ 0x3c4, 0x4, 0xe},
	{ 0x3ce, 0x5, 0x40},
	{ 0x3ce, 0x6, 0x5},
	{ 0x3c0, 0x10, 0x41},
	{ 0x3c0, 0x13, 0x0}

};

vgareg v256x256S[] =
{
  { 0x3c2, 0x00, 0xe3},{ 0x3d4, 0x00, 0x5F},{ 0x3d4, 0x01, 0x3f},
  { 0x3d4, 0x02, 0x40},{ 0x3d4, 0x03, 0x82},{ 0x3d4, 0x04, 0x4a},
  { 0x3d4, 0x05, 0x9a},{ 0x3d4, 0x06, 0x23},{ 0x3d4, 0x07, 0x15},
  { 0x3d4, 0x08, 0x00},{ 0x3d4, 0x09, 0x60},{ 0x3d4, 0x10, 0x0a},
  { 0x3d4, 0x11, 0xac},{ 0x3d4, 0x12, 0xff},{ 0x3d4, 0x13, 0x20},
  { 0x3d4, 0x14, 0x40},{ 0x3d4, 0x15, 0x07},{ 0x3d4, 0x16, 0x1a},
  { 0x3d4, 0x17, 0xa3},{ 0x3c4, 0x01, 0x01},{ 0x3c4, 0x04, 0x0e},
  { 0x3ce, 0x05, 0x40},{ 0x3ce, 0x06, 0x05},{ 0x3c0, 0x10, 0x41},
  { 0x3c0, 0x13, 0x00}
};

void SetBorder(void)
{
vga_lockvc();
inportb(0x3da);outportb(0x3c0,(0x11|0x20));
if(vmode==4 || vmode==5)
 outportb(0x3c0,0);
else
 outportb(0x3c0,128);
if(!conlock) vga_unlockvc();
}

static void VGAPortSet(vgareg R)
{
  switch (R.p)
  {
    case 0x3C0: inportb(0x3DA);
                outportb(0x3C0,R.i|0x20);
                outportb(0x3C0,R.v);
                break;
    case 0x3C2:
    case 0x3C3: outportb(R.p, R.v);
                break;
    case 0x3C4:
    case 0x3CE:
    case 0x3D4:
    default:    outportb(R.p,R.i);
                outportb(R.p+1,R.v);
                break;
  }
}

void TweakVGA (int VGAMode)
{
  int I;

  vga_lockvc();

  outportb(0x3C8,0x00);
  for(I=0;I<768;I++) outportb(0x3C9,0x00);

  outportb(0x3D4,0x11);
  I=inportb(0x3D5)&0x7F;
  outportb(0x3D4,0x11);
  outportb(0x3D5,I);

  switch(VGAMode)
  {
    case 1:  for(I=0;I<25;I++) VGAPortSet(v256x240[I]);break;
    case 2:  for(I=0;I<25;I++) VGAPortSet(v256x256[I]);break;
    case 3:  for(I=0;I<25;I++) VGAPortSet(v256x256S[I]);break;
    case 6:  for(I=0;I<25;I++) VGAPortSet(v256x224S[I]);break;
    default: break;
  }
  outportb(0x3da,0);
  if(!conlock) vga_unlockvc();
  return;
}

static unsigned char palettedbr[256],palettedbg[256],palettedbb[256];

void GetPalette(unsigned char i, unsigned char *r, unsigned char *g, unsigned char *b)
{
 *r=palettedbr[i];
 *g=palettedbg[i];
 *b=palettedbb[i];
}
void SetPalette(unsigned char index, unsigned char r, unsigned char g, unsigned char b)
{
 if(winit&1)
 {
  palettedbr[index]=r;
  palettedbg[index]=g;
  palettedbb[index]=b;
  if(vmode==4 || vmode==5) index^=0x80;
  vga_setpalette(index,r>>2,g>>2,b>>2);
 }
}

void FlusherifyPalette(void)
{
 int x;
 for(x=0;x<256;x++)
 {
  int z=x;
  if(vmode==4 || vmode==5) z^=0x80;
  vga_setpalette(z,palettedbr[z]>>2,palettedbg[z]>>2,palettedbb[z]>>2);
 }
}
void vcfix(void)
{
 int z;

 vga_lockvc();
 z=inportb(0x3cc);
 if(!conlock) vga_unlockvc();
 if(z!=0xe3) 
  {TweakVGA(vmode);SetBorder();FlusherifyPalette();}
}

int SetVideoMode(void)
{
 switch(vmode){
 default:
 case 1:vga_setmode(G320x200x256);ScreenLoc=vga_getgraphmem();TweakVGA(1);SetBorder();break;
 case 2:vga_setmode(G320x200x256);ScreenLoc=vga_getgraphmem();TweakVGA(2);SetBorder();break;
 case 3:vga_setmode(G320x200x256);ScreenLoc=vga_getgraphmem();TweakVGA(3);SetBorder();break;
 case 5:
 case 4:
	vga_setmode(G320x200x256);
	ScreenLoc=vga_getgraphmem();
	if(!(vga_getmodeinfo(G640x480x256)->flags & CAPABLE_LINEAR))
        {
	puts("No VESA linear addressing mode available!");
	return 0;
        }
        if(vga_setmode(G640x480x256)==-1)
	{
	puts("Could not set 640x480x256 VESA video mode!");
	return 0;
	}
	vga_setpage(0);
	if(vga_setlinearaddressing()!=-1)
 	 ScreenLoc=vga_getgraphmem();
	else
	{
	puts("Could not set VESA linear addressing!");
	return 0;
	}
	SetBorder();
	break;
   case 6:vga_setmode(G320x200x256);ScreenLoc=vga_getgraphmem();TweakVGA(6);SetBorder();break;
 }
 if(vmode==4 || vmode==5)
  memset(vga_getgraphmem(),0,640*480);
 else
  memset(vga_getgraphmem(),128,256*256);
 winit|=1;
 return 1;
}

void BlitScreen(unsigned char *XBuf, int maxline)
{
 static int conto=0;
 unsigned char *dest;
 
 dest=ScreenLoc;
 if(vmode!=4 || vmode!=5)
 {
  conto=(conto+1)&0x3F;
  if(!conto) vcfix();
 }
 switch(vmode)
 {
  case 1:dest+=(((240-maxline)>>1)<<8);break;
  case 2:
  case 3:dest+=(((256-maxline)>>1)<<8);break;
  case 4:
  case 5:dest+=(((240-maxline)>>1)*640+((640-512)>>1));break;
  case 6:maxline=224;break;
 }

if(vmode==5)
{
asm volatile(
     "xorl %%edx, %%edx\n\t"
     "koop1:\n\t"
     "movb $128,%%al     \n\t"
     "koop2:\n\t"
     "movb 1(%%esi),%%dl\n\t"
     "shl  $16,%%edx\n\t"
     "movb (%%esi),%%dl\n\t"
     "xorl $0x00800080,%%edx\n\t"
     "movl %%edx,(%%edi)\n\t"
     "addl $2,%%esi\n\t"
     "addl $4,%%edi\n\t"
     "decb %%al\n\t"
     "jne koop2\n\t"
  
     "addl $16,%%esi\n\t"
     "addl $768,%%edi\n\t"
     "decb %%bl\n\t"
     "jne koop1\n\t"
     :
     : "S" (XBuf), "D" (dest), "b" (maxline)
     : "%al", "%edx", "%cc" );
}
else if(vmode==4)
{
asm volatile(
     "yoop1:\n\t"
     "movb $128,%%al     \n\t"
     "yoop2:\n\t"
     "movb 1(%%esi),%%dh\n\t"
     "movb %%dh,%%dl\n\t"
     "shl  $16,%%edx\n\t"
     "movb (%%esi),%%dl\n\t"
     "movb %%dl,%%dh\n\t"               // Ugh
     "xorl $0x80808080,%%edx\n\t"
     "movl %%edx,(%%edi)\n\t"
     "addl $2,%%esi\n\t"
     "addl $4,%%edi\n\t"
     "decb %%al\n\t"
     "jne yoop2\n\t"

     "addl $16,%%esi\n\t"
     "addl $768,%%edi\n\t"
     "decb %%bl\n\t"
     "jne yoop1\n\t"
     :
     : "S" (XBuf), "D" (dest), "b" (maxline)
     : "%al", "%edx", "%cc" );
}
else
{
#ifdef NONO	// This is very fast, but it causes "artifacts" on my screen
int x,y;
for(y=maxline;y;y--)
 {
  for(x=16;x;x--)
  {
   double z,z2;
   z=*(double *)XBuf;
   z2=*(double *)&XBuf[8];
   *(double *)dest=z;
   *(double *)&dest[8]=z2;
   XBuf+=16;
   dest+=16;
  }
  XBuf+=16;
 }
#endif
asm volatile(
     "goop1:\n\t"
     "movl $32,%%eax\n\t"
     "goop2:\n\t"  
     "movl (%%esi),%%edx\n\t"
     "movl 4(%%esi),%%ecx\n\t"
     "movl %%edx,(%%edi)\n\t"
     "movl %%ecx,4(%%edi)\n\t"
     "addl $8,%%esi\n\t"
     "addl $8,%%edi\n\t"
     "decl %%eax\n\t"
     "jne goop2\n\t"
     "addl $16,%%esi\n\t"
     "decb %%bl\n\t"
     "jne goop1\n\t"
     :
     : "S" (XBuf), "D" (dest), "b" (maxline)
     : "%eax","%cc","%edx","%ecx" );
 }
}
int soundo;
int sasync=0;
int dowait=1;
void WaitForVBlank(void)
{
 if(dowait)
 { 
  if(sasync && soundo)
  { 
    wackyer:
     if(vretrace)
     {
     vretrace--;
     }
     else
      goto wackyer;
  }
 else
 {
   if(vmode==3 || vmode==6)
   {
   if(soundo)
    {
    wacky:
     if(vretrace)
     {
       {
       vretrace--;
       if(!vretrace) {IfVBlank();}
       } 
     }
     else
      goto wacky;
    }
   }
   else
    WaitVBlank();
  }
 }
}

/* Begin joystick section */
static int joy[4]={0,0,0,0};
static int joyvar[32];
static unsigned long butmask=0;

#define joyxmin(x)	joyvar[((x)<<3)]
#define joyxmax(x)	joyvar[((x)<<3)+1]
#define joyymin(x)	joyvar[((x)<<3)+2]
#define joyymax(x)	joyvar[((x)<<3)+3]
#define joyb_a(x)	joyvar[((x)<<3)+4]
#define joyb_b(x)	joyvar[((x)<<3)+5]
#define joyb_select(x)	joyvar[((x)<<3)+6]
#define joyb_start(x)	joyvar[((x)<<3)+7]

static unsigned char axes;
static unsigned char buttons;

static void ConfigJoystick(int z);
static int fd[4];

static int version;

static struct JS_DATA_TYPE js;
#define JOY_A   1
#define JOY_B   2
#define JOY_SELECT      4
#define JOY_START       8
#define JOY_UP  0x10
#define JOY_DOWN        0x20
#define JOY_LEFT        0x40
#define JOY_RIGHT       0x80

unsigned long GetJSOr(void)
{
int x;
unsigned long ret;
ret=0;

 for(x=0;x<4;x++)
 {
  if(!joy[x]) continue;
  read(fd[x], &js, JS_RETURN);
  if(js.buttons&joyb_b(x)) ret|=JOY_B<<(x<<3);
   if(js.buttons&joyb_a(x)) ret|=JOY_A<<(x<<3);
    if(js.buttons&joyb_select(x)) ret|=JOY_SELECT<<(x<<3);
     if(js.buttons&joyb_start(x)) ret|=JOY_START<<(x<<3);
  if(js.x<=joyxmin(x)) ret|=JOY_LEFT<<(x<<3);
  else if(js.x>=joyxmax(x)) ret|=JOY_RIGHT<<(x<<3);
  if(js.y<=joyymin(x)) ret|=JOY_UP<<(x<<3);
  else if(js.y>=joyymax(x)) ret|=JOY_DOWN<<(x<<3);
 }
return ret;
}
void KillJoystick(void)
{
int x;
for(x=0;x<4;x++)
 if(joy[x]) close(fd[x]);
}

int InitJoystick(void)
{
char dbuf[64];
int z,x;
       for(z=0;z<4;z++)
       {
        if(!joy[z]) continue;
        sprintf(dbuf,"/dev/js%d",joy[z]-1);
        if((fd[z]=open(dbuf,O_RDONLY))<0) {
           printf("Could not open %s.\n",dbuf);
           joy[z]=0;
	   continue;
        }
        ioctl(fd[z], JSIOCGVERSION, &version);
        ioctl(fd[z], JSIOCGAXES, &axes);
        ioctl(fd[z], JSIOCGBUTTONS, &buttons);
        for(x=0;x<buttons;x++)
         butmask|=1<<x;
        if((version>>16)>=1 && ((version>>8)&0xff)>=2 && (version&0xFF)>=8)
         { // It's a new version.
          joyxmin(z)=joyymin(z)=64;
          joyxmax(z)=joyymax(z)=192;
         }
         else
         { // Old version of joystick driver.
          read(fd[z],&js,JS_RETURN);
          joyxmin(z)=js.x/2;
          joyxmax(z)=js.x*3/2;
          joyymin(z)=js.y/2;
          joyymax(z)=js.y*3/2;
         }
        if(joyb_a(z)==0 && joyb_b(z)==0 && joyb_select(z)==0 && joyb_start(z)==0)
         ConfigJoystick(z);
       }
  return(joy[0]|joy[1]|joy[2]|joy[3]);
}

#define JW1 alarm(10);for(;;){read(fd[z], &js, JS_RETURN);if((js.buttons)&butmask || skip){skip=0;break;}}
#define JW2 alarm(10);for(;;){read(fd[z], &js, JS_RETURN);if(!((js.buttons)&butmask) || skip){skip=0;break;}}
int skip=0;
static void doskip(void);
void ConfigJoystick(int z)
{
 signal(SIGALRM,(void *)doskip);
 printf("\n\n Joystick button configuration:\n\n");
 printf("   Push the button to map to the virtual joystick.\n");
 printf("   If you do not wish to assign a button, wait for a few seconds,\n");
 printf("   and it will time out.\n\n");
 printf("   Press enter to continue...\n");getchar();
  printf("****  Configuring joystick %d ****\n\n",z+1);
  printf("** Press button for \"Select\".\n");
  JW1;
  joyb_select(z)=js.buttons&butmask;
  JW2;
  printf("** Press button for \"Start\".\n");
  read(fd[z], &js, JS_RETURN);
  JW1;joyb_start(z)=js.buttons&butmask;JW2;
 
  printf("** Press button for \"B\".\n");
  read(fd[z], &js, JS_RETURN);
  JW1;joyb_b(z)=js.buttons&butmask;JW2;
 
  printf("** Press button for \"A\".\n");
  read(fd[z], &js, JS_RETURN);
  JW1;joyb_a(z)=js.buttons&butmask;JW2;
}

static void doskip(void)
{
skip=1;
}

void KeyboardClose(void)
{
if(winit&2) keyboard_close();
}

int KeyboardInitialize(void)
{
  DoClone();
  if(keyboard_init()==-1) return 0;
  keyboard_translatekeys(TRANSLATE_CURSORKEYS | TRANSLATE_DIAGONAL);
  winit|=2;
  return 1;
}

int KeyboardUpdate(void)
{
 if(didup) {didup=0;return 1;}
 return keyboard_update();
}

char *KeyboardGetstate(void)
{
 return keyboard_getstate();
}

int LockConsole(void)
{
 vga_lockvc();
 conlock=1;
 return 1;
}

int UnlockConsole(void)
{
 vga_unlockvc();
 conlock=0;
 return 1;
}

void ResetVideo(void)
{
 if(winit&1)
 {
  vga_setmode(TEXT);
 }
}

void PrintFatalError(char *s)
{
 puts(s);
}
static char BaseDirectory[2048];

#include "config.c"
#include "netplay.c"

static void CreateDirs(void)
{
 mkdir(BaseDirectory,S_IRWXU|S_IRGRP|S_IROTH);
 sprintf(TempArray,"%s/fcs",BaseDirectory);
 mkdir(TempArray,S_IRWXU|S_IRGRP|S_IROTH);
 sprintf(TempArray,"%s/snaps",BaseDirectory);
 mkdir(TempArray,S_IRWXU|S_IRGRP|S_IROTH);
}

static void GetBaseDirectory(void)
{
 char *ol;
 ol=getenv("HOME");
 BaseDirectory[0]=0;
 if(ol) 
  {
   strncpy(BaseDirectory,ol,2037);
   BaseDirectory[2037]=0;
   strcat(BaseDirectory,"/.fceultra");
   DriverInterface(DES_BASEDIR,BaseDirectory);
  }
}

void SetSignals(void (*t)(int))
{
  int sigs[11]={SIGINT,SIGTERM,SIGHUP,SIGPIPE,SIGSEGV,SIGFPE,SIGKILL,SIGALRM,SIGABRT,SIGUSR1,SIGUSR2};
  int x;
  for(x=0;x<11;x++)
   signal(sigs[x],t);
}

void CloseStuff(int signum)
{
	DriverKill();
        printf("\nSignal %d has been caught and dealt with...\n",signum);
        switch(signum)
        {
        case SIGINT:printf("How DARE you interrupt me!\n");break;
        case SIGTERM:printf("MUST TERMINATE ALL HUMANS\n");break;
        case SIGHUP:printf("Reach out and hang-up on someone.\n");break;
        case SIGPIPE:printf("The pipe has broken!  Better watch out for floods...\n");break;
        case SIGSEGV:printf("Iyeeeeeeeee!!!  A segmentation fault has occurred.  Have a fluffy day.\n");break;
        case SIGBUS:printf("I told you to be nice to the driver.\n");break;
        case SIGFPE:printf("Those darn floating points.  Ne'er know when they'll bite!\n");break;
        case SIGKILL:printf("Your OS must be very screwy if you're reading this!\n");break;
        case SIGALRM:printf("Don't throw your clock at the meowing cats!\n");break;
        case SIGABRT:printf("Abort, Retry, Ignore, Fail?\n");break;
        case SIGUSR1:
        case SIGUSR2:printf("Killing your processes is not nice.\n");break;
        }
        exit(1);
}

int main(int argc, char *argv[])
{
	vga_init();
        GetBaseDirectory();
	CreateDirs();
        if(argc<=1) {CheckArgs();return 1;}
        sprintf(TempArray,"%s/fceu.cfg",BaseDirectory);
        LoadConfig(TempArray);
        DoArgs(argc, argv);
	return fceumain(argv[argc-1]);
}

int DriverInitialize(void)
{
   int t;
 
   SetSignals((void *)CloseStuff);
   t=1;
   if(InitJoystick()) DriverInterface(DES_JOYSTICK,&t);
   if(soundo)
   {
    soundo=InitSound();
    if(soundo) DriverInterface(DES_SOUND,&soundo);
   }
   if(!SetVideoMode()) return 0;
   KeyboardInitialize();
   return 1;
}

void DriverKill(void)
{
 sprintf(TempArray,"%s/fceu.cfg",BaseDirectory);
 SaveConfig(TempArray);
 SetSignals(SIG_IGN);
 if(joy[0]|joy[1]|joy[2]|joy[3]) KillJoystick();
 KeyboardClose();
 ResetVideo();
 if(soundo) TrashSound();
}
