/****************************************************************/
/*			FCE Ultra				*/
/*								*/
/*	This file contains routines for reading/writing the     */
/*	configuration file, and for getting arguments		*/
/*								*/
/****************************************************************/

void GetValue(FILE *fp, char *str, int *v)
{
 char buf[256],buf2[32];
 while(fgets(buf,256,fp))
  {
   int v2;
   sscanf(buf,"%[^=] %*[=] %d",buf2,&v2);
   if(!strcmp(str,buf2)) *v=v2;
  }
  rewind(fp);
}

void GetValueString(FILE *fp, char *str, char *v)
{
 char buf[256],buf2[32];
 v[0]=0;
 while(fgets(buf,256,fp))
  {
   char v2[1024];
   sscanf(buf,"%[^=] %*[=] %s",buf2,v2);
   if(!strcmp(str,buf2)) {strcpy(v,v2);}
  }
  rewind(fp);
}

void SetValue(FILE *fp, char *str, int v)
{
 fprintf(fp,"%s=%d\n",str,v);
}

void SetValueString(FILE *fp, char *str, char *str2)
{
 fprintf(fp,"%s=%s\n",str,str2);
}


void SaveConfig(char *filename)
{
FILE *fp;
int x;
char gorf[16];
fp=fopen(filename,"wb");
if(fp==NULL) return;
SetValue(fp,"palyo",palyo);
SetValue(fp,"genie",genie);
SetValue(fp,"fs",fullscreen);
SetValue(fp,"vgamode",vmod);
SetValue(fp,"sound",soundo?1:0);
SetValue(fp,"soundplevel",soundplevel);
SetValue(fp,"soundwait",soundwait);

SetValue(fp,"joy1",joy[0]);
SetValue(fp,"joy2",joy[1]);
SetValue(fp,"joy3",joy[2]);
SetValue(fp,"joy4",joy[3]);

for(x=0;x<4;x++)
 {
  sprintf(gorf,"joyA%d",x);
  SetValue(fp,gorf,joyA[x]);
 }
for(x=0;x<4;x++)
 {
  sprintf(gorf,"joyB%d",x);
  SetValue(fp,gorf,joyB[x]);
 }
for(x=0;x<4;x++)
 {
  sprintf(gorf,"joySelect%d",x);
  SetValue(fp,gorf,joySelect[x]);
 }
for(x=0;x<4;x++)
 {
  sprintf(gorf,"joyStart%d",x);
  SetValue(fp,gorf,joyStart[x]);
 }

DriverInterface(DES_GETNTSCTINT,&x);
SetValue(fp,"ntsctint",x);
DriverInterface(DES_GETNTSCHUE,&x);
SetValue(fp,"ntschue",x);
SetValue(fp,"ntsccol",ntsccol);

SetValue(fp,"ssync",ssync);
SetValue(fp,"dowait",dowait);
SetValueString(fp,"gfsdir",gfsdir);
fclose(fp);
}

void LoadConfig(char *filename)
{
FILE *fp;
char gorf[16];
int x;

fp=fopen(filename,"rb");
if(fp==NULL) return;

GetValue(fp,"palyo",&palyo);
palyo&=1;
DriverInterface(DES_VIDSYS,&palyo);
GetValue(fp,"genie",&genie);
genie&=1;
DriverInterface(DES_GENIE,&genie);
GetValue(fp,"fs",&fullscreen);
fullscreen&=1;
GetValue(fp,"vgamode",&vmod);
GetValue(fp,"sound",&soundo);
soundo&=1;
GetValue(fp,"soundplevel",&soundplevel);
GetValue(fp,"soundwait",&soundwait);

GetValue(fp,"joy1",&joy[0]);
GetValue(fp,"joy2",&joy[1]);
GetValue(fp,"joy3",&joy[2]);
GetValue(fp,"joy4",&joy[3]);
for(x=0;x<4;x++)
 {
  sprintf(gorf,"joyA%d",x);
  GetValue(fp,gorf,&joyA[x]);
 }
for(x=0;x<4;x++)
 {
  sprintf(gorf,"joyB%d",x);
  GetValue(fp,gorf,&joyB[x]);
 }
for(x=0;x<4;x++)
 {
  sprintf(gorf,"joySelect%d",x);
  GetValue(fp,gorf,&joySelect[x]);
 }
for(x=0;x<4;x++)
 {
  sprintf(gorf,"joyStart%d",x);
  GetValue(fp,gorf,&joyStart[x]);
 }

GetValue(fp,"ntsccol",&ntsccol);
DriverInterface(DES_NTSCCOL,&ntsccol);
GetValue(fp,"ntsctint",&x);
DriverInterface(DES_SETNTSCTINT,&x);
GetValue(fp,"ntschue",&x);
DriverInterface(DES_SETNTSCHUE,&x);
GetValue(fp,"ssync",&ssync);
ssync&=1;
GetValue(fp,"dowait",&dowait);
dowait&=1;
GetValueString(fp,"gfsdir",gfsdir);
fclose(fp);
}
